Date sent:        Thu, 19 Jun 1997 00:50:03 +0200 (MET DST)
From:             Patrik Haggblad <dig-it@eagle.y.se>
To:               azure@hamburg.roses.de

;
; Wind/Network contribution for the Starfield-bytesize-compo on #amycoders:
;
; My first try was at about 140-150 bytes, but now it's on 108 bytes...
;
; 
; please note that anyone can use this source provided he at least changes
; something meaningfull, such as adding colors, shading, rotation, etc....
; if you wanna use it as-is, you should credit me, oki?
;
; Wind/Network
; network@redestb.es
;
; Antonio Vargas
; Relator 67, 1
; 41003 Sevilla
; Spain          (spain.... wasn't it in africa or smthng??? ;)
;
        *********************    ***********************  
      ******      .                              .  ******
     ****     .  .   .  Init & Exit code     .        **** 
    ***   '         .                .   *** 
    **  .  .    . .                        .    . .      ** 
    **              written in a hurry for     . .       ** 
    ***  .  :   . .          .     *** 
     ****          #Amycoders' starfield compo      by **** 
      ******    .        morbid  
        *********************    ***********************   
                


************* stuff for cheking codesize

check	equ	0	; 108

	ifne	check

	move.l	#codesize,d0
	rts

	endc

************* 

        bsr     CloseWB         ; Flush view and disable multitasking
        bsr     OpenScreen      ; Set pointers and sync

        jsr     Starfield_init  ;Init starfield
        
**
************************************************************
************************************************************
**
**                    >>> M A I N <<<
**



        


Main    btst    #6,$bfe001
        beq     Exit
        
        
        
************************************************************


        bsr     DisplayScreen
        jsr     Starfield       ;call starfield (a0=Bitplane)
        bra     Main




        
**
************************************************************
**
**      Flush view & disable system
**


CloseWB

        movea.l 4.w,a6          ; exec base
        jsr     -132(a6)        ; Forbid
        jsr     -120(a6)        ; Disable
        lea     GfxName(pc),a1  ; graphics.library
        moveq   #0,d0           ; whatever verision
        jsr     -552(a6)        ; open it !
        move.l  d0,GfxBase      ; store gfxbase
        movea.l d0,a6           ; gfxbase in a6
        move.l  $22(a6),OldView ; store system view
        move.l  $26(a6),OldCop  ; store system copper
        sub.l   a1,a1
        jsr     -222(a6)        ; flush view (LoadView)
        jsr     -270(a6)        ; WaitTOF
        jsr     -270(a6)        ; twice for interlaced views
        move.w  $dff002,OldDMAcon   ; store old dma control register
        ori.w   #$8000,OldDMAcon  ; set bit #15
        move.w  #$7fff,$dff096
        move.w  #$8380,$dff096
        rts
        
        
GfxName dc.b 'graphics.library',0
        even
GfxBase dc.l 0
OldView dc.l 0
OldCop  dc.l 0
OldDMAcon dc.w 0

        cnop 0,4

**
*************************************************************
**
**      Display Screen
**

DisplayScreen

        movem.l d0-d1,-(sp)

        move.b  $bfe801,d0
.wait   cmp.b   $bfe801,d0
        beq.b   .wait
        
        move.l  screen_logical(pc),d0
        move.l  screen_physical(pc),screen_logical
        move.l  d0,screen_physical

        lea     copper_bpl,a0
        move.w  d0,6(a0)                ; lower part of bpl address
        swap    d0
        move.w  d0,2(a0)                ; higher word

        movea.l screen_logical(pc),a0   
        moveq   #0,d0
        move.l  #(320/32)*256-1,d1
.clear  move.l  d0,(a0)+                ; clear logical screen
        dbf     d1,.clear
        lea     -(320/8)*256(a0),a0     
        
        movem.l (sp)+,d0-d1
        rts


screen_physical dc.l 0
screen_logical dc.l 0

        
**
*************************************************************
**
**      Open Screen
**

OpenScreen
        
        lea     $dff000,a5
        move.l  #Copper,$80(a5)
        
        move.w  #$2c81,$08e(a5)         ; display window start pos
        move.w  #$2cc1,$090(a5)         ; display window stop pos
        move.w  #$0038,$092(a5)         ; data fetch start pos
        move.w  #$00d0,$094(a5)         ; data fetch stop pos

        move.l  #ScreenA,screen_logical
        move.l  #ScreenB,screen_physical
        bsr     DisplayScreen
        
        rts
        
**
**************************************************************
**
**      Open WB 
**

Exit
        lea     $dff000,a5
        move.w  #$7fff,$96(a5)          ; clear dmacon
        move.w  OldDMAcon(pc),$96(a5)   ; set old bits
        move.l  GfxBase(pc),a6          ; gfxbase in a6
        move.l  OldCop(pc),$80(a5)      ; restart old copperlist
        move.l  OldView(pc),a1
        jsr     -222(a6)                ; Load system view
        
        move.l  a6,a1
        move.l  4.w,a6
        jsr     -414(a6)                ; close graphics.library
        jsr     -126(a6)                ; Enable
        jsr     -138(a6)                ; Permit
        
        rts
        
        

************************************************************************

        section screens,bss_c
        
ScreenA ds.b (320*256)/8
ScreenB ds.b (320*256)/8

************************************************************************

        section copperlist,data_c

        
Copper  dc.l $01001000  ; bplcon0
        dc.l $01080000  ; bpl1mod
        dc.l $010a0000  ; bpl2mod
        dc.l $01800000  ; colour 0 = black
        dc.l $01820fff  ; colour 1 = white
                
copper_bpl
        dc.l $00e00000  ; bpl1pth
        dc.l $00e20000  ; bpl1ptl


        dc.l $fffffffe


**************************************************************************
**************************************************************************
**
**
**  Your starfield code starts here
**
**
**************************************************************************
**************************************************************************


        section code,code       ;put your code here

*********************************************
** Do all initialisations here
*********************************************

Starfield_init:
a
	lea	vars,a6

	move.w	#(512*3)-1,d7
.init1	bsr.b	dorandom
	move.w	d6,(a6)+
	dbra	d7,.init1
	rts

dorandom
	add.l	d1,d6		; cool random number generator
	eor.w	d6,d1
b
        rts

*********************************************
** This routine is called once a frame
**
** The destination Bitplane is given in a0
*********************************************


;
; please note there ALWAYS are 512 stars on screen
;
c

limit1	dc.w	-160,159
limit2	dc.w	-128,127

nopaint	; new pixel is generated when one is out of bounds
	sub.w	d6,-(a6)	; Z
	bsr.b	dorandom
	add.l	d1,-(a6)	; new X & Y
	bra.b	starloop

Starfield:
	lea	vars,a6

	eor.l	d5,d5		; d5 = $00000000
	not.w	d5		; d5 = $0000ffff

	moveq.l	#40,d4

	lea	limit1(pc),a5
	lea	limit2(pc),a4

	move.w	#511,d7
starloop
	movem.w	(a6)+,d0/d1
	sub.w	d4,(a6)		; speed = 40
	move.w	(a6)+,d2
	ble.b	nopaint		; new star if z<=0

	divs.w	d2,d0		; perspective
	divs.w	d2,d1

	cmp2.w	(a5),d0		; check X border
	bcs.b	nopaint

	cmp2.w	(a4),d1		; check Y border
	bcs.b	nopaint

	sub.w	(a5),d0		; x-(-160)
	sub.w	(a4),d1		; y-(-128)

	mulu.w	d4,d1		; y*40
	and.l	d5,d0		; fix X offset (clear high word)

	bfset	(a0,d1.l){d0:1}	; plot pixel using bitfield

	dbra	d7,starloop
d
        rts

codesize	equ	(d-c)+(b-a)

        section bss,bss         ;put your tables heres

vars	ds.l	(512*3)		;stars

